if ('undefined' == typeof SothinkFlashDownloader) {
	SothinkFlashDownloader = {};
}
(function() {
	var tabbrowser = window.parent.document.getElementById('content'),
	lastTime = new Date().getTime(),
	listengap = 3000;

	SothinkFlashDownloader.Global = {
		panelInsertedCb: function(evt) {
			try {
				if (evt.relatedNode != tabbrowser.mPanelContainer) return;
				var browser = evt.target.childNodes[1];
				browser.addProgressListener(SothinkFlashDownloader.webListener);
			} catch(e) {
				alert("SothinkFlashDownloaderGlobal.panelInsertedCb: " + e);
			}
		},
		panelRemovedCb: function(evt) {
			try {
				if (evt.relatedNode != tabbrowser.mPanelContainer) return; //Could be anywhere in the DOM (unless bubbling is caught at the interface?)
				var browser = evt.target.childNodes[1];
				browser.removeProgressListener(SothinkFlashDownloader.webListener);
			} catch(e) {
				alert("SothinkFlashDownloaderGlobal.panelRemovedCb: " + e);
			}
		},
		panelInsertedCb2: function(evt) {
			try {
				var browser = evt.target.linkedBrowser;
				browser.addProgressListener(SothinkFlashDownloader.webListener);
			} catch(e) {
				alert("SothinkFlashDownloaderGlobal.panelInsertedCb2: " + e);
			}
		},
		panelRemovedCb2: function(evt) {
			try {
				var browser = evt.target.linkedBrowser;
				browser.removeProgressListener(SothinkFlashDownloader.webListener);
			} catch(e) {
				alert("SothinkFlashDownloaderGlobal.panelRemovedCb2: " + e);
			}
		},
		hookPanelListeners: function() {
			try {
				for (var i = 0; i < tabbrowser.browsers.length; i++) {
					tabbrowser.browsers[i].addProgressListener(SothinkFlashDownloader.webListener);
				}
				if (navigator.userAgent.indexOf("Firefox") != -1) {
					var versionindex = navigator.userAgent.indexOf("Firefox") + 8;
					var version = parseInt(navigator.userAgent.charAt(versionindex)+navigator.userAgent.charAt(versionindex+1));
					if (version < 2) {
						tabbrowser.mPanelContainer.addEventListener("DOMNodeInserted", SothinkFlashDownloader.Global.panelInsertedCb, false);
						tabbrowser.mPanelContainer.addEventListener("DOMNodeRemoved", SothinkFlashDownloader.Global.panelRemovedCb, false);
					} else {
						tabbrowser.tabContainer.addEventListener("TabOpen", SothinkFlashDownloader.Global.panelInsertedCb2, false);
						tabbrowser.tabContainer.addEventListener("TabClose", SothinkFlashDownloader.Global.panelRemovedCb2, false);
					}
				}
				tabbrowser.tabContainer.addEventListener('select', SothinkFlashDownloader.Sidebar.init, false);
			} catch(e) {
				alert("SothinkFlashDownloaderGlobal.hookPanelListeners: " + e);
			}
		},
		unhookPanelListeners: function() {
			try {
				var browser0 = tabbrowser.browsers[0];
				browser0.removeProgressListener(SothinkFlashDownloader.webListener);

				var container = tabbrowser.mPanelContainer;
				if (navigator.userAgent.indexOf("Firefox") != -1) {
					var versionindex = navigator.userAgent.indexOf("Firefox") + 8;
					var version = parseInt(navigator.userAgent.charAt(versionindex)+navigator.userAgent.charAt(versionindex+1));
					if (version < 2) {
						tabbrowser.mPanelContainer.removeEventListener("DOMNodeInserted", SothinkFlashDownloader.Global.panelInsertedCb, false);
						tabbrowser.mPanelContainer.removeEventListener("DOMNodeRemoved", SothinkFlashDownloader.Global.panelRemovedCb, false);
					} else {
						tabbrowser.tabContainer.removeEventListener("TabOpen", SothinkFlashDownloader.Global.panelInsertedCb2, false);
						tabbrowser.tabContainer.removeEventListener("TabClose", SothinkFlashDownloader.Global.panelRemovedCb2, false);
					}
				}
				tabbrowser.tabContainer.removeEventListener('select', SothinkFlashDownloader.Sidebar.init, false);
			} catch(e) {
				alert("SothinkFlashDownloaderGlobal.unhookPanelListeners: " + e);
			}
		}
	};

	SothinkFlashDownloader.webListener = {
		QueryInterface: function(aIID) {
			if (aIID.equals(Components.interfaces.nsIWebProgressListener) || aIID.equals(Components.interfaces.nsISupportsWeakReference) || aIID.equals(Components.interfaces.nsISupports)) return this;
			throw Components.results.NS_NOINTERFACE;
		},
		onLocationChange: function(awebProgress, arequest, alocation) {
			//occurs before the url  being loaded
			//SothinkFlashDownloaderParse.doWebParse();
			//alert("onLocationChange"+window.location.href);
		},
		onProgressChange: function(awebProgress, arequest, acurSelfProgress, amaxSelfProgress, acurTotalProgress, amaxTotalProgress) {
			var curTime = (new Date()).getTime();
			if (curTime - lastTime >= listengap) {
				SothinkFlashDownloader.Parse.doWebParse();
				lastTime = curTime;
			}
		},
		onSecurityChange: function(awebProgress, arequest, astate) {

},
		onStateChange: function(awebProgress, arequest, aStateFlags, astatus) {
			if (! ((aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP) && (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW))) {
				return;
			}
			SothinkFlashDownloader.Parse.doWebParse();
			//alert("onStateChange");
		},
		onStatusChange: function(awebProgress, arequest, astatus, amessage) {
			// alert("onStatusChange");
		}
	};
})();