if ('undefined' == typeof SothinkFlashDownloader) {
    var SothinkFlashDownloader = {};
}
SothinkFlashDownloader.Overlay = (function() {
    var CurrentTable, Timer, FlaTimer, FlvTimer, TempDirFile, ExSwfPath, glImageFla, glFlaEvent, glSrc, SWF_FILETYPE = "swf",
    FLV_FILETYPE = "flv",
    ImgFla = "http://www.sothink.com/product/swfcatcher/firefox/image/fla.png",
    ImgFlaNoDec = "http://www.sothink.com/product/swfcatcher/firefox/image/fla_d.png",
    ImgFlash = "http://www.sothink.com/product/swfcatcher/firefox/image/save.png";
    function $() {
        return document.getElementById(arguments[0]);
    }
    return {
        init: function() {
            window.addEventListener("load", SothinkFlashDownloader.Overlay.OnWindowLoad, true);
            window.addEventListener("unload", SothinkFlashDownloader.Overlay.onWindowUnload, false);
        },
        getFileType: function(contentType, url) {
            if (contentType == "application/x-shockwave-flash") {
                return "swf";
            }
            if ((contentType == "video/x-flv") || (contentType == "video/flv")) {
                return "flv";
            } else {
                var urlExt = url.substr(url.lastIndexOf(".") + 1, 3);
                if (urlExt == "flv") {
                    return "flv";
                }
            }
            if (contentType == "video/mp4") {
                return "mp4";
            }
            return "";
        },
        getBrowser: function(aChannel, aSubject) {
            try {
                var notificationCallbacks = aChannel.notificationCallbacks ? aChannel.notificationCallbacks: aSubject.loadGroup.notificationCallbacks;
                if (!notificationCallbacks) return null;

                var callback = notificationCallbacks.getInterface(Components.interfaces.nsIDOMWindow);
                return callback.top.document ? gBrowser.getBrowserForDocument(callback.top.document) : null;
            } catch(e) {
                return null;
            }
        },
        addFile: function(doc, params) {
            doc.swfList = doc.swfList || [];
            doc.flvList = doc.flvList || [];
            if (params.fileType == "swf") {
                SothinkFlashDownloader.Overlay.addToList(doc.swfList, params);
            }
            if ((params.fileType == "flv") || (params.fileType == "mp4")) {
                SothinkFlashDownloader.Overlay.addToList(doc.flvList, params);
            }
            SothinkFlashDownloader.Overlay.setStatusBar(doc);
        },
        addToList: function(list, params) {
            for (var i = 0; i < list.length; i++) {
                if (list[i].url == params.url) {
                    return false;
                }
            }
            list.push(params);
        },
        setStatusBar: function(doc) {
            if (getBrowser().selectedBrowser.contentDocument != doc) {
                return false;
            }
            doc.swfList = doc.swfList || [];
            doc.flvList = doc.flvList || [];

            if ((doc.swfList.length > 0) || (doc.flvList.length > 0)) {
                if ((doc.swfList.length == 0) && (doc.flvList.length > 0)) {
                    if (FlvTimer) {
                        clearInterval(FlvTimer);
                    }
                    $("flashDownloadStatusbarPanel").setAttribute("hidden", "true");
                    $("flashDownloadStatusbarFlv").setAttribute("hidden", "false");
                    $("flashDownloadStatusbarSwf").setAttribute("hidden", "true");
                }

                if ((doc.swfList.length > 0) && (doc.flvList.length == 0)) {
                    if (FlvTimer) {
                        clearInterval(FlvTimer);
                    }
                    $("flashDownloadStatusbarPanel").setAttribute("hidden", "true");
                    $("flashDownloadStatusbarFlv").setAttribute("hidden", "true");
                    $("flashDownloadStatusbarSwf").setAttribute("hidden", "false");
                }

                if ((doc.swfList.length > 0) && (doc.flvList.length > 0)) {
                    if (FlvTimer) {
                        clearInterval(FlvTimer);
                        SothinkFlashDownloader.Overlay.changeStatusBar();
                    }
                }
            } else {
                if (FlvTimer) {
                    clearInterval(FlvTimer);
                }
                $("flashDownloadStatusbarPanel").setAttribute("hidden", "false");
                $("flashDownloadStatusbarFlv").setAttribute("hidden", "true");
                $("flashDownloadStatusbarSwf").setAttribute("hidden", "true");
            }
        },
        changeStatusBar: function() {
            $("flashDownloadStatusbarPanel").setAttribute("hidden", "true");
            $("flashDownloadStatusbarFlv").setAttribute("hidden", "true");
            $("flashDownloadStatusbarSwf").setAttribute("hidden", "false");
            clearInterval(FlvTimer);

            FlvTimer = setInterval(function() {
                SothinkFlashDownloader.Overlay.changeStatusBar();
            },
            1000);
        },
        getElPos: function(o) {
            var pos = {
                x: 0,
                y: 0
            };
            while ((o.offsetParent) && (o.tagName.toLowerCase() != 'body')) {
                pos.x += o.offsetLeft;
                pos.y += o.offsetTop;
                o = o.offsetParent;
            }
            pos.x += o.offsetLeft;
            pos.y += o.offsetTop;
            return pos;
        },
        getDownloadFile: function(swfname, defaultSaveSWFDir, fileFilter) {
            var nsIFilePicker = Components.interfaces.nsIFilePicker;
            var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
            fp.init(window, '', nsIFilePicker.modeSave);
            fp.defaultString = swfname;

            var localFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
            localFile.initWithPath(defaultSaveSWFDir);

            fp.displayDirectory = localFile;
            fp.appendFilter(fileFilter, "*." + fileFilter);

            var rv = fp.show();
            if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
                var file = fp.file;
                var path = fp.file.path;
                return file;
            }
            return null;
        },
        downloadFlash: function(swfUrl) {
            var swfname = SothinkFlashDownloader.Overlay.GetSwfName(swfUrl);
            //if (SothinkFlashDownloader.Overlay.IsWindowPlatform()) {
                var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.swfcatcher.");
                var defaultPath = null;
                if (objectionPrefs.getCharPref("path_default") == "null") {
                    var dirService = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
                    var tempDirFile = dirService.get("Desk", Components.interfaces.nsIFile);
                    defaultPath = tempDirFile.path;
                } else defaultPath = decodeURIComponent(escape(objectionPrefs.getCharPref("path_default")));

                var file = SothinkFlashDownloader.Overlay.getDownloadFile(swfname, defaultPath, SWF_FILETYPE);
                var persist = Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1'].createInstance(Components.interfaces.nsIWebBrowserPersist);
                var ios = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
                var uri = ios.newURI(swfUrl, null, null);
                if (!file) {
                    return;
                }
                var target = ios.newFileURI(file);
                var xfer = Components.classes["@mozilla.org/transfer;1"].createInstance(Components.interfaces.nsITransfer);
                xfer.init(uri, target, "", null, null, null, persist, null);
                persist.progressListener = xfer;
                persist.saveURI(uri, null, null, null, null, file, null);
            //} else {
            //    window.parent.saveURL(swfUrl, swfname);
            //}
        },
        GetSwfName: function(path) {
            if (path.substring(0, 8) == "file:///") {
                try {
                    var file = new File(SothinkFlashDownloader.Tree.localfromfilepath(path));
                    var tmpPath;
                    if (file.exists()) {
                        tmpPath = file.leaf();
                        return tmpPath;
                    } else {
                        tmpPath = path.substring(path.lastIndexOf("/") + 1);
                        return tmpPath;
                    }
                } catch(e) {
                    alert(e);
                    return null;
                }
            }

            if (path.substring(0, 7) == "http://") {
                var myurl = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURL);
                myurl.spec = path;
                var afilename = SothinkFlashDownloader.Parse.testContain(myurl.fileName, ".swf") ? myurl.fileName: myurl.fileName + ".swf";
                return afilename;
            }
        },
        OnElementMouseOver: function(event) {
            if (!event || !event.target) {
                return false;
            }
            if (event.target.tagName == 'EMBED' || event.target.tagName == 'OBJECT' || ((event.target.previousSibling)&&(event.target.previousSibling.nodeName == "OBJECT")) || ((event.target.nextSibling)&&(event.target.nextSibling.nodeName == "OBJECT"))) {
                if(((event.target.previousSibling)&&(event.target.previousSibling.nodeName == "OBJECT")) || ((event.target.nextSibling)&&(event.target.nextSibling.nodeName == "OBJECT"))){
                    var embed = (event.target.previousSibling)? event.target.previousSibling : event.target.nextSibling;
                }else{
                    var embed = event.target;
                }
                var doc = embed.ownerDocument;
                var pos = SothinkFlashDownloader.Overlay.getElPos(embed);
                var w = pos.x + embed.clientWidth;
                var h = pos.y + embed.clientHeight;
                var isInTheWidth = (event.clientX >= pos.x) && (event.clientX <= w);
                var isInTheHeight = (event.clientY <= pos.y) && (event.clientY <= h);

                if (isInTheWidth) {
                    SothinkFlashDownloader.Overlay.OnShowFloatBar(doc, embed);
                }
            } else {
                return false;
            }
            return true;
        },
        OnElementMouseOut: function(event) {
            if (!event || !event.target) {
                return false;
            }
            var embed = event.target;
            var doc = embed.ownerDocument;
            var pos = SothinkFlashDownloader.Overlay.getElPos(embed);
            var w = pos.x + embed.clientWidth;
            var h = pos.y + embed.clientHeight;
            var isInTheWidth = (event.clientX >= pos.x) && (event.clientX <= w);
            var isInTheHeight = (event.clientY >= pos.y) && (event.clientY <= h);
            if (!isInTheWidth) {
                SothinkFlashDownloader.Overlay.OnHideFloatBar();
            }
            return true;
        },
        OnShowFloatBar: function(doc, embed) {
            var _body = doc.getElementsByTagName("body")[0];
            if (CurrentTable == null) {
                CurrentTable = doc.createElement("div");
                _body.appendChild(CurrentTable);

                var _table = doc.createElement("table");
                var _tablebody = doc.createElement("tbody");
                var _row = doc.createElement("tr");
                var _colDownload = _row.insertCell(0);
                var _colDec = _row.insertCell(1);

                var _embedSrc = (embed.src != null) ? embed.src: embed.data;
                var _imgFlash = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "xul:image");
                _imgFlash.setAttribute("width", "35");
                _imgFlash.setAttribute("height", "22");
                _imgFlash.setAttribute("src", ImgFlash);
                _imgFlash.setAttribute("style", "cursor:pointer");
                _imgFlash.addEventListener("click",
                function(e) {
                    SothinkFlashDownloader.Overlay.downloadFlash(_embedSrc);
                },
                false);
                _colDownload.appendChild(_imgFlash);

                _tablebody.appendChild(_row);
                _table.appendChild(_tablebody);
                CurrentTable.appendChild(_table);

                var pos = SothinkFlashDownloader.Overlay.getElPos(embed);
                CurrentTable.style.position = "absolute";
                CurrentTable.style.zIndex = "10000";
                CurrentTable.style.left = pos.x + "px";

                if (embed.clientWidth < 144 || embed.clientHeight < 44) {
                    CurrentTable.style.top = (pos.y - 26) + "px"; // show floatbar on left_top of swf
                } else {
                    CurrentTable.style.top = (pos.y) + "px";
                }
                CurrentTable.style.width = "72px";
                CurrentTable.style.height = "22px";
                CurrentTable.style.border = "0px solid #ff0000";
                CurrentTable.style.display = '';
            }
        },
        OnHideFloatBar: function() {
            if (CurrentTable != null) {
                CurrentTable.style.display = 'none';
                CurrentTable = null;
            }
        },
        DelTmpFolder: function(event) {
            var dirService = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
            var TempDirFile = dirService.get("TmpD", Components.interfaces.nsIFile);
            TempDirFile.append("SothinkFD");
            if (TempDirFile.exists() && TempDirFile.isDirectory()) {
                TempDirFile.remove(true);
            }
        },
        IsWindowPlatform: function() {
            var isWin = (navigator.platform == "Win32") || (navigator.platform == "Windows");
            return isWin;
        },
        IsMacPlatform: function() {
            var isMac = (navigator.platform == "Mac68k") || (navigator.platform == "MacPPC") || (navigator.platform == "Macintosh") || (navigator.platform == "MacIntel");
            return isMac;
        },
        OnWindowLoad: function(event) {
            CurrentTable = null;
            glImageFla = null;
            glFlaEvent = null;
            glSrc = null;

            var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
            observerService.addObserver(SothinkFlashDownloader.Observer, "http-on-examine-response", false);
            observerService.addObserver(SothinkFlashDownloader.Observer, "http-on-modify-request", false);
            observerService.addObserver(SothinkFlashDownloader.Observer, "http-on-examine-cached-response", false);

            var listener = {
                onStatusChange: function() {},
                onStateChange: function() {},
                onLocationChange: function(aProgress, aRequest, aURI) {
                    if (aURI == null) {
                        $("flashDownloadStatusbarPanel").setAttribute("hidden", "false");
                        $("flashDownloadStatusbarFlv").setAttribute("hidden", "true");
                        $("flashDownloadStatusbarSwf").setAttribute("hidden", "true");
                    } else {
                        SothinkFlashDownloader.Overlay.setStatusBar(getBrowser().selectedBrowser.contentDocument);
                    }
                },
                onProgressChange: function() {},
                onSecurityChange: function() {}
            };
            var b = SothinkFlashDownloader.Overlay.getBrowser();
            if (b) {
                b.addProgressListener(listener, Components.interfaces.nsIWebProgress.NOTIFY_LOCATION);
            }
            var parentWindow = event.originalTarget.defaultView;
            var elements = parentWindow.document.getElementsByTagName("*");

            for (var i = 0; i < elements.length; i++) {
                if (elements[i].tagName != "IFRAME" && elements[i].tagName != "FRAME") {
                    elements[i].onmouseover = SothinkFlashDownloader.Overlay.OnElementMouseOver;
                    elements[i].onmouseout = SothinkFlashDownloader.Overlay.OnElementMouseOut;
                }
            }

            SothinkFlashDownloader.Overlay.DelTmpFolder();
        },
        onWindowUnload: function() {
            var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
            observerService.removeObserver(SothinkFlashDownloader.Observer, "http-on-examine-response", false);
            observerService.removeObserver(SothinkFlashDownloader.Observer, "http-on-modify-request", false);
            observerService.removeObserver(SothinkFlashDownloader.Observer, "http-on-examine-cached-response", false);
        }
    };
})();

SothinkFlashDownloader.Observer = {
    observe: function(aSubject, aTopic, aData) {
        if ((aTopic == "http-on-examine-response") || (aTopic == "http-on-modify-request") || (aTopic == "http-on-examine-cached-response")) {
            try {
                aSubject.QueryInterface(Components.interfaces.nsIRequest);
                var url = aSubject.name;
                var contentType = aSubject.contentType;
                var contentLength = aSubject.contentLength;
                var fileType = SothinkFlashDownloader.Overlay.getFileType(contentType, url);
                aSubject.QueryInterface(Components.interfaces.nsIChannel);
                if ((fileType == "swf") || (fileType == "flv") || (fileType == "mp4")) {
                    var browser = SothinkFlashDownloader.Overlay.getBrowser(aSubject, aSubject);
                    var doc = browser.contentDocument;
                    var title = doc.title;
                    var domain = doc.domain;
                    var href = doc.location.href;
                    SothinkFlashDownloader.Overlay.addFile(doc, {
                        title: title,
                        domain: domain,
                        href: href,
                        fileType: fileType,
                        contentType: contentType,
                        contentLength: contentLength,
                        url: url,
                        doc: doc
                    });
                }
            } catch(e) {

            }
        }
    },
    QueryInterface: function(aIID) {
        if (aIID.equals(Components.interfaces.nsISupports) || aIID.equals(Components.interfaces.nsIObserver)) {
            return this;
        }
        throw Components.results.NS_NOINTERFACE;
    }
}

SothinkFlashDownloader.Overlay.init();